org.apache.poi.poifs.crypt.dsig.facets

## Class OOXMLSignatureFacet

- java.lang.Object
- - org.apache.poi.poifs.crypt.dsig.facets.SignatureFacet
  - - org.apache.poi.poifs.crypt.dsig.facets.OOXMLSignatureFacet

- All Implemented Interfaces:
    SignatureConfig.SignatureConfigurable

      public class OOXMLSignatureFacet
      extends SignatureFacet

  Office OpenXML Signature Facet implementation.
  See Also:
    [MS-OFFCRYPTO]: Office Document Cryptography Structure

- - ### Field Summary

    - ### Fields inherited from class org.apache.poi.poifs.crypt.dsig.facets.SignatureFacet

      `MS_DIGSIG_NS, OO_DIGSIG_NS, signatureConfig, XADES_132_NS, XADES_141_NS, XML_DIGSIG_NS, XML_NS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OOXMLSignatureFacet()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addManifestObject(org.w3c.dom.Document document, java.util.List<javax.xml.crypto.dsig.Reference> references, java.util.List<javax.xml.crypto.dsig.XMLObject> objects)`
    `protected void` | `addManifestReferences(java.util.List<javax.xml.crypto.dsig.Reference> manifestReferences)`
    `protected void` | `addSignatureInfo(org.w3c.dom.Document document, java.util.List<javax.xml.crypto.dsig.Reference> references, java.util.List<javax.xml.crypto.dsig.XMLObject> objects)`
    `protected void` | `addSignatureTime(org.w3c.dom.Document document, java.util.List<javax.xml.crypto.XMLStructure> objectContent)`
    `protected static java.lang.String` | `getRelationshipReferenceURI(java.lang.String zipEntryName)`
    `protected static java.lang.String` | `getResourceReferenceURI(java.lang.String resourceName, java.lang.String contentType)`
    `protected static boolean` | `isSignedRelationship(java.lang.String relationshipType)`
    `void` | `preSign(org.w3c.dom.Document document, java.util.List<javax.xml.crypto.dsig.Reference> references, java.util.List<javax.xml.crypto.dsig.XMLObject> objects)` This method is being invoked by the XML signature service engine during pre-sign phase.

    - ### Methods inherited from class org.apache.poi.poifs.crypt.dsig.facets.SignatureFacet

      `getSignatureFactory, newReference, newReference, newTransform, newTransform, postSign, setSignatureConfig`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### OOXMLSignatureFacet

          public OOXMLSignatureFacet()

  - ### Method Detail

    - #### preSign

          public void preSign(org.w3c.dom.Document document,
                              java.util.List<javax.xml.crypto.dsig.Reference> references,
                              java.util.List<javax.xml.crypto.dsig.XMLObject> objects)
                       throws javax.xml.crypto.dsig.XMLSignatureException

      Description copied from class: `SignatureFacet`
      This method is being invoked by the XML signature service engine during pre-sign phase. Via this method a signature facet implementation can add signature facets to an XML signature.
      Overrides:
        `preSign` in class `SignatureFacet`
      Parameters:
        `document` - the signature document to be used for imports
        `references` - list of reference definitions
        `objects` - objects to be signed/included in the signature document
      Throws:
        `javax.xml.crypto.dsig.XMLSignatureException`

    - #### addManifestObject

          protected void addManifestObject(org.w3c.dom.Document document,
                                           java.util.List<javax.xml.crypto.dsig.Reference> references,
                                           java.util.List<javax.xml.crypto.dsig.XMLObject> objects)
                                    throws javax.xml.crypto.dsig.XMLSignatureException

      Throws:
        `javax.xml.crypto.dsig.XMLSignatureException`

    - #### addManifestReferences

          protected void addManifestReferences(java.util.List<javax.xml.crypto.dsig.Reference> manifestReferences)
                                        throws javax.xml.crypto.dsig.XMLSignatureException

      Throws:
        `javax.xml.crypto.dsig.XMLSignatureException`

    - #### addSignatureTime

          protected void addSignatureTime(org.w3c.dom.Document document,
                                          java.util.List<javax.xml.crypto.XMLStructure> objectContent)

    - #### addSignatureInfo

          protected void addSignatureInfo(org.w3c.dom.Document document,
                                          java.util.List<javax.xml.crypto.dsig.Reference> references,
                                          java.util.List<javax.xml.crypto.dsig.XMLObject> objects)
                                   throws javax.xml.crypto.dsig.XMLSignatureException

      Throws:
        `javax.xml.crypto.dsig.XMLSignatureException`

    - #### getRelationshipReferenceURI

          protected static java.lang.String getRelationshipReferenceURI(java.lang.String zipEntryName)

    - #### getResourceReferenceURI

          protected static java.lang.String getResourceReferenceURI(java.lang.String resourceName,
                                                                    java.lang.String contentType)

    - #### isSignedRelationship

          protected static boolean isSignedRelationship(java.lang.String relationshipType)

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.